diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/test/wifi-primary-channels-test.cc ns-3.44/src/wifi/test/wifi-primary-channels-test.cc
--- ns-3.43/src/wifi/test/wifi-primary-channels-test.cc	2024-10-09 16:41:10.140657000 -0700
+++ ns-3.44/src/wifi/test/wifi-primary-channels-test.cc	2025-03-09 16:55:49.811372800 -0700
@@ -33,10 +33,10 @@
 NS_LOG_COMPONENT_DEFINE("WifiPrimaryChannelsTest");
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief Test transmissions under different primary channel settings
+ * @brief Test transmissions under different primary channel settings
  *
  * This test can be repeated for different widths of the operating channel. We
  * configure as many BSSes as the number of distinct 20 MHz subchannels in the
@@ -54,8 +54,8 @@
     /**
      * Constructor
      *
-     * \param channelWidth the operating channel width
-     * \param useDistinctBssColors whether to set distinct BSS colors to BSSes
+     * @param channelWidth the operating channel width
+     * @param useDistinctBssColors whether to set distinct BSS colors to BSSes
      */
     WifiPrimaryChannelsTest(MHz_u channelWidth, bool useDistinctBssColors);
     ~WifiPrimaryChannelsTest() override;
@@ -64,10 +64,10 @@
      * Callback invoked when PHY receives a PSDU to transmit. Used to print
      * transmitted PSDUs for debug purposes.
      *
-     * \param context the context
-     * \param psduMap the PSDU map
-     * \param txVector the TX vector
-     * \param txPowerW the tx power in Watts
+     * @param context the context
+     * @param psduMap the PSDU map
+     * @param txVector the TX vector
+     * @param txPowerW the tx power in Watts
      */
     void Transmit(std::string context,
                   WifiConstPsduMap psduMap,
@@ -77,18 +77,18 @@
      * Have the AP of the given BSS transmit a SU PPDU using the given
      * transmission channel width
      *
-     * \param bss the given BSS
-     * \param txChannelWidth the given transmission channel width
+     * @param bss the given BSS
+     * @param txChannelWidth the given transmission channel width
      */
     void SendDlSuPpdu(uint8_t bss, MHz_u txChannelWidth);
     /**
      * Have the AP of the given BSS transmit a MU PPDU using the given
      * transmission channel width and RU type
      *
-     * \param bss the given BSS
-     * \param txChannelWidth the given transmission channel width
-     * \param ruType the given RU type
-     * \param nRus the number of RUs
+     * @param bss the given BSS
+     * @param txChannelWidth the given transmission channel width
+     * @param ruType the given RU type
+     * @param nRus the number of RUs
      */
     void SendDlMuPpdu(uint8_t bss, MHz_u txChannelWidth, HeRu::RuType ruType, std::size_t nRus);
     /**
@@ -96,52 +96,52 @@
      * DoSendHeTbPpdu to actually have STAs transmit HE TB PPDUs using the given
      * transmission channel width and RU type
      *
-     * \param bss the given BSS
-     * \param txChannelWidth the given transmission channel width
-     * \param ruType the given RU type
-     * \param nRus the number of RUs
+     * @param bss the given BSS
+     * @param txChannelWidth the given transmission channel width
+     * @param ruType the given RU type
+     * @param nRus the number of RUs
      */
     void SendHeTbPpdu(uint8_t bss, MHz_u txChannelWidth, HeRu::RuType ruType, std::size_t nRus);
     /**
      * Have the STAs of the given BSS transmit an HE TB PPDU using the given
      * transmission channel width and RU type
      *
-     * \param bss the given BSS
-     * \param txChannelWidth the given transmission channel width
-     * \param ruType the given RU type
-     * \param nRus the number of RUs
+     * @param bss the given BSS
+     * @param txChannelWidth the given transmission channel width
+     * @param ruType the given RU type
+     * @param nRus the number of RUs
      */
     void DoSendHeTbPpdu(uint8_t bss, MHz_u txChannelWidth, HeRu::RuType ruType, std::size_t nRus);
     /**
      * Callback invoked when a station receives a DL PPDU.
      *
-     * \param bss the BSS the receiving STA belongs to
-     * \param station the receiving station
-     * \param psdu the received PSDU
-     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
-     * \param txVector TxVector of the received PSDU
-     * \param perMpduStatus per MPDU reception status
+     * @param bss the BSS the receiving STA belongs to
+     * @param station the receiving station
+     * @param psdu the received PSDU
+     * @param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * @param txVector TxVector of the received PSDU
+     * @param perMpduStatus per MPDU reception status
      */
     void ReceiveDl(uint8_t bss,
                    uint8_t station,
                    Ptr<const WifiPsdu> psdu,
                    RxSignalInfo rxSignalInfo,
-                   WifiTxVector txVector,
-                   std::vector<bool> perMpduStatus);
+                   const WifiTxVector& txVector,
+                   const std::vector<bool>& perMpduStatus);
     /**
      * Callback invoked when an AP receives an UL PPDU.
      *
-     * \param bss the BSS the receiving AP belongs to
-     * \param psdu the received PSDU
-     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
-     * \param txVector TxVector of the received PSDU
-     * \param perMpduStatus per MPDU reception status
+     * @param bss the BSS the receiving AP belongs to
+     * @param psdu the received PSDU
+     * @param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * @param txVector TxVector of the received PSDU
+     * @param perMpduStatus per MPDU reception status
      */
     void ReceiveUl(uint8_t bss,
                    Ptr<const WifiPsdu> psdu,
                    RxSignalInfo rxSignalInfo,
-                   WifiTxVector txVector,
-                   std::vector<bool> perMpduStatus);
+                   const WifiTxVector& txVector,
+                   const std::vector<bool>& perMpduStatus);
     /**
      * Check that all stations associated with an AP.
      */
@@ -153,8 +153,8 @@
      * filtering) or if no transmission was performed on a channel adjacent to the one
      * they operate on, otherwise.
      *
-     * \param txBss the set of BSSes that transmitted an SU PPDU
-     * \param txChannelWidth the given transmission channel width
+     * @param txBss the set of BSSes that transmitted an SU PPDU
+     * @param txChannelWidth the given transmission channel width
      */
     void CheckReceivedSuPpdus(std::set<uint8_t> txBss, MHz_u txChannelWidth);
     /**
@@ -164,11 +164,11 @@
      * filtering) or if no transmission addressed to/from stations with the same AID was
      * performed on a channel adjacent to the one they operate on, otherwise.
      *
-     * \param txBss the set of BSSes that transmitted an SU PPDU
-     * \param txChannelWidth the given transmission channel width
-     * \param ruType the given RU type
-     * \param nRus the number of RUs
-     * \param isDlMu true for DL MU PPDU, false for HE TB PPDU
+     * @param txBss the set of BSSes that transmitted an SU PPDU
+     * @param txChannelWidth the given transmission channel width
+     * @param ruType the given RU type
+     * @param nRus the number of RUs
+     * @param isDlMu true for DL MU PPDU, false for HE TB PPDU
      */
     void CheckReceivedMuPpdus(std::set<uint8_t> txBss,
                               MHz_u txChannelWidth,
@@ -181,8 +181,8 @@
      * any frame Trigger Frame (given that a Trigger Frame is transmitted on the primary20
      * channel and all the primary20 channels are distinct).
      *
-     * \param txBss the set of BSSes that transmitted a Trigger Frame
-     * \param txChannelWidth the given transmission channel width
+     * @param txBss the set of BSSes that transmitted a Trigger Frame
+     * @param txChannelWidth the given transmission channel width
      */
     void CheckReceivedTriggerFrames(std::set<uint8_t> txBss, MHz_u txChannelWidth);
 
@@ -244,8 +244,8 @@
                                    uint8_t station,
                                    Ptr<const WifiPsdu> psdu,
                                    RxSignalInfo rxSignalInfo,
-                                   WifiTxVector txVector,
-                                   std::vector<bool> perMpduStatus)
+                                   const WifiTxVector& txVector,
+                                   const std::vector<bool>& perMpduStatus)
 {
     if (psdu->GetNMpdus() == 1)
     {
@@ -279,8 +279,8 @@
 WifiPrimaryChannelsTest::ReceiveUl(uint8_t bss,
                                    Ptr<const WifiPsdu> psdu,
                                    RxSignalInfo rxSignalInfo,
-                                   WifiTxVector txVector,
-                                   std::vector<bool> perMpduStatus)
+                                   const WifiTxVector& txVector,
+                                   const std::vector<bool>& perMpduStatus)
 {
     // if the BSS color is zero, this AP might receive the frame sent by another AP. Given that
     // stations only send TB PPDUs, we ignore this frame if the TX vector is not UL MU.
@@ -343,7 +343,7 @@
     }
 
     // we create as many BSSes as the number of 20 MHz subchannels
-    m_nBss = m_channelWidth / 20;
+    m_nBss = Count20MHzSubchannels(m_channelWidth);
 
     NodeContainer wifiApNodes;
     wifiApNodes.Create(m_nBss);
@@ -422,7 +422,7 @@
         for (uint8_t bss = 0; bss < m_nBss; bss++)
         {
             auto dev = DynamicCast<WifiNetDevice>(m_apDevices.Get(bss));
-            dev->GetHeConfiguration()->SetBssColor(bss + 1);
+            dev->GetHeConfiguration()->m_bssColor = bss + 1;
         }
     }
 
@@ -463,7 +463,7 @@
                                      1,
                                      1,
                                      0,
-                                     20,
+                                     MHz_u{20},
                                      false,
                                      false,
                                      false);
@@ -548,7 +548,7 @@
      * |     |-----|     |-----|     |-----|     |-----|
      *
      * Then, we double the transmission channel width. We will have four rounds
-     * of transmissions. We avoid using adjacent channels to avoid interfence
+     * of transmissions. We avoid using adjacent channels to avoid interference
      * among transmissions:
      *
      *      AP0                     AP4
@@ -607,9 +607,10 @@
 
     // To have simultaneous transmissions on adjacent channels, just initialize
     // nRounds to 1 and nApsPerRound to m_channelWidth / 20. Of course, the test
-    // will fail because some stations will not receive some frames due to interfence
-    for (MHz_u txChannelWidth = 20, nRounds = 2, nApsPerRound = m_channelWidth / 20 / 2;
-         txChannelWidth <= m_channelWidth;
+    // will fail because some stations will not receive some frames due to interference
+    uint16_t nRounds = 2;
+    uint16_t nApsPerRound = Count20MHzSubchannels(m_channelWidth) / 2;
+    for (MHz_u txChannelWidth{20}; txChannelWidth <= m_channelWidth;
          txChannelWidth *= 2, nRounds *= 2, nApsPerRound /= 2)
     {
         nRounds = std::min<uint16_t>(nRounds, m_nBss);
@@ -644,8 +645,9 @@
      * channel width, every round is repeated as many times as the number of ways in
      * which we can partition the transmission channel width in equal sized RUs.
      */
-    for (MHz_u txChannelWidth = 20, nRounds = 2, nApsPerRound = m_channelWidth / 20 / 2;
-         txChannelWidth <= m_channelWidth;
+    nRounds = 2;
+    nApsPerRound = Count20MHzSubchannels(m_channelWidth) / 2;
+    for (MHz_u txChannelWidth{20}; txChannelWidth <= m_channelWidth;
          txChannelWidth *= 2, nRounds *= 2, nApsPerRound /= 2)
     {
         nRounds = std::min<uint16_t>(nRounds, m_nBss);
@@ -692,8 +694,9 @@
      * channel width, every round is repeated as many times as the number of ways in
      * which we can partition the transmission channel width in equal sized RUs.
      */
-    for (MHz_u txChannelWidth = 20, nRounds = 2, nApsPerRound = m_channelWidth / 20 / 2;
-         txChannelWidth <= m_channelWidth;
+    nRounds = 2;
+    nApsPerRound = Count20MHzSubchannels(m_channelWidth) / 2;
+    for (MHz_u txChannelWidth{20}; txChannelWidth <= m_channelWidth;
          txChannelWidth *= 2, nRounds *= 2, nApsPerRound /= 2)
     {
         nRounds = std::min<uint16_t>(nRounds, m_nBss);
@@ -759,7 +762,7 @@
     auto apDev = DynamicCast<WifiNetDevice>(m_apDevices.Get(bss));
     auto staDev = DynamicCast<WifiNetDevice>(m_staDevices[bss].Get(0));
 
-    uint8_t bssColor = apDev->GetHeConfiguration()->GetBssColor();
+    uint8_t bssColor = apDev->GetHeConfiguration()->m_bssColor;
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs8(),
                                          0,
                                          WIFI_PREAMBLE_HE_SU,
@@ -794,7 +797,7 @@
                            << "addressed to " << nRus << " stations (RU type: " << ruType << ")");
 
     auto apDev = DynamicCast<WifiNetDevice>(m_apDevices.Get(bss));
-    uint8_t bssColor = apDev->GetHeConfiguration()->GetBssColor();
+    uint8_t bssColor = apDev->GetHeConfiguration()->m_bssColor;
 
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs8(),
                                          0,
@@ -819,7 +822,7 @@
 
     for (std::size_t i = 1; i <= nRus; i++)
     {
-        bool primary80 = !(txChannelWidth == 160 && i > nRus / 2);
+        bool primary80 = !(txChannelWidth == MHz_u{160} && i > nRus / 2);
         std::size_t index = (primary80 ? i : i - nRus / 2);
 
         auto staDev = DynamicCast<WifiNetDevice>(m_staDevices[bss].Get(i - 1));
@@ -830,7 +833,7 @@
     }
     txVector.SetSigBMode(VhtPhy::GetVhtMcs5());
     RuAllocation ruAllocations;
-    const std::size_t numRuAllocs = txChannelWidth / 20;
+    const auto numRuAllocs = Count20MHzSubchannels(txChannelWidth);
     ruAllocations.resize(numRuAllocs);
     auto IsOddNum = (nRus / numRuAllocs) % 2 == 1;
     auto ruAlloc = HeRu::GetEqualizedRuAllocation(ruType, IsOddNum);
@@ -871,7 +874,7 @@
                                         std::size_t nRus)
 {
     auto apDev = DynamicCast<WifiNetDevice>(m_apDevices.Get(bss));
-    uint8_t bssColor = apDev->GetHeConfiguration()->GetBssColor();
+    uint8_t bssColor = apDev->GetHeConfiguration()->m_bssColor;
 
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_QOSDATA);
@@ -880,7 +883,7 @@
     hdr.SetAddr3(apDev->GetMac()->GetBssid(0));
     hdr.SetSequenceNumber(1);
 
-    Time duration = Seconds(0);
+    Time duration;
     uint16_t length = 0;
     WifiTxVector trigVector(HePhy::GetHeMcs8(),
                             0,
@@ -901,7 +904,7 @@
                                << txChannelWidth
                                << " MHz channel an HE TB PPDU (RU type: " << ruType << ")");
 
-        bool primary80 = !(txChannelWidth == 160 && i > nRus / 2);
+        bool primary80 = !(txChannelWidth == MHz_u{160} && i > nRus / 2);
         std::size_t index = (primary80 ? i : i - nRus / 2);
 
         auto staDev = DynamicCast<WifiNetDevice>(m_staDevices[bss].Get(i - 1));
@@ -1209,10 +1212,10 @@
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief Test functions returning the indices of primary and secondary channels
+ * @brief Test functions returning the indices of primary and secondary channels
  *        of different width.
  */
 class Wifi20MHzChannelIndicesTest : public TestCase
@@ -1228,12 +1231,12 @@
      * Check that the indices of the 20 MHz channels included in all the primary
      * and secondary channels are correct when setting the given primary20 channel.
      *
-     * \param primary20 the index of the primary20 channel to configure
-     * \param secondary20 the expected index of the secondary20 channel
-     * \param primary40 the expected indices of the 20 MHz channels in the primary40 channel
-     * \param secondary40 the expected indices of the 20 MHz channels in the secondary40 channel
-     * \param primary80 the expected indices of the 20 MHz channels in the primary80 channel
-     * \param secondary80 the expected indices of the 20 MHz channels in the secondary80 channel
+     * @param primary20 the index of the primary20 channel to configure
+     * @param secondary20 the expected index of the secondary20 channel
+     * @param primary40 the expected indices of the 20 MHz channels in the primary40 channel
+     * @param secondary40 the expected indices of the 20 MHz channels in the secondary40 channel
+     * @param primary80 the expected indices of the 20 MHz channels in the primary80 channel
+     * @param secondary80 the expected indices of the 20 MHz channels in the secondary80 channel
      */
     void RunOne(uint8_t primary20,
                 const std::set<uint8_t>& secondary20,
@@ -1274,7 +1277,7 @@
 
     m_channel.SetPrimary20Index(primary20);
 
-    auto actualPrimary20 = m_channel.GetAll20MHzChannelIndicesInPrimary(20);
+    auto actualPrimary20 = m_channel.GetAll20MHzChannelIndicesInPrimary(MHz_u{20});
     NS_TEST_ASSERT_MSG_EQ((actualPrimary20 == std::set<uint8_t>{primary20}),
                           true,
                           "Expected Primary20 {" << +primary20 << "}"
@@ -1288,7 +1291,7 @@
                                                   << " differs from actual "
                                                   << printToStr(actualSecondary20));
 
-    auto actualPrimary40 = m_channel.GetAll20MHzChannelIndicesInPrimary(40);
+    auto actualPrimary40 = m_channel.GetAll20MHzChannelIndicesInPrimary(MHz_u{40});
     NS_TEST_ASSERT_MSG_EQ((actualPrimary40 == primary40),
                           true,
                           "Expected Primary40 " << printToStr(primary40) << " differs from actual "
@@ -1301,7 +1304,7 @@
                                                   << " differs from actual "
                                                   << printToStr(actualSecondary40));
 
-    auto actualPrimary80 = m_channel.GetAll20MHzChannelIndicesInPrimary(80);
+    auto actualPrimary80 = m_channel.GetAll20MHzChannelIndicesInPrimary(MHz_u{80});
     NS_TEST_ASSERT_MSG_EQ((actualPrimary80 == primary80),
                           true,
                           "Expected Primary80 " << printToStr(primary80) << " differs from actual "
@@ -1319,23 +1322,23 @@
 Wifi20MHzChannelIndicesTest::DoRun()
 {
     /* 20 MHz channel */
-    m_channel.SetDefault(20, WIFI_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+    m_channel.SetDefault(MHz_u{20}, WIFI_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
     RunOne(0, {}, {}, {}, {}, {});
 
     /* 40 MHz channel */
-    m_channel.SetDefault(40, WIFI_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+    m_channel.SetDefault(MHz_u{40}, WIFI_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
     RunOne(0, {1}, {0, 1}, {}, {}, {});
     RunOne(1, {0}, {0, 1}, {}, {}, {});
 
     /* 80 MHz channel */
-    m_channel.SetDefault(80, WIFI_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+    m_channel.SetDefault(MHz_u{80}, WIFI_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
     RunOne(0, {1}, {0, 1}, {2, 3}, {0, 1, 2, 3}, {});
     RunOne(1, {0}, {0, 1}, {2, 3}, {0, 1, 2, 3}, {});
     RunOne(2, {3}, {2, 3}, {0, 1}, {0, 1, 2, 3}, {});
     RunOne(3, {2}, {2, 3}, {0, 1}, {0, 1, 2, 3}, {});
 
     /* 160 MHz channel */
-    m_channel.SetDefault(160, WIFI_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+    m_channel.SetDefault(MHz_u{160}, WIFI_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
     RunOne(0, {1}, {0, 1}, {2, 3}, {0, 1, 2, 3}, {4, 5, 6, 7});
     RunOne(1, {0}, {0, 1}, {2, 3}, {0, 1, 2, 3}, {4, 5, 6, 7});
     RunOne(2, {3}, {2, 3}, {0, 1}, {0, 1, 2, 3}, {4, 5, 6, 7});
@@ -1347,10 +1350,10 @@
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief wifi primary channels test suite
+ * @brief wifi primary channels test suite
  */
 class WifiPrimaryChannelsTestSuite : public TestSuite
 {
@@ -1362,14 +1365,14 @@
     : TestSuite("wifi-primary-channels", Type::UNIT)
 {
     // Test cases for 20 MHz can be added, but are not that useful (there would be a single BSS)
-    AddTestCase(new WifiPrimaryChannelsTest(40, true), TestCase::Duration::QUICK);
-    AddTestCase(new WifiPrimaryChannelsTest(40, false), TestCase::Duration::QUICK);
+    AddTestCase(new WifiPrimaryChannelsTest(MHz_u{40}, true), TestCase::Duration::QUICK);
+    AddTestCase(new WifiPrimaryChannelsTest(MHz_u{40}, false), TestCase::Duration::QUICK);
 #if 0
     // Tests disabled until issue #776 resolved
-    AddTestCase(new WifiPrimaryChannelsTest(80, true), TestCase::Duration::EXTENSIVE);
-    AddTestCase(new WifiPrimaryChannelsTest(80, false), TestCase::Duration::EXTENSIVE);
-    AddTestCase(new WifiPrimaryChannelsTest(160, true), TestCase::Duration::TAKES_FOREVER);
-    AddTestCase(new WifiPrimaryChannelsTest(160, false), TestCase::Duration::TAKES_FOREVER);
+    AddTestCase(new WifiPrimaryChannelsTest(MHz_u{80}, true), TestCase::Duration::EXTENSIVE);
+    AddTestCase(new WifiPrimaryChannelsTest(MHz_u{80}, false), TestCase::Duration::EXTENSIVE);
+    AddTestCase(new WifiPrimaryChannelsTest(MHz_u{160}, true), TestCase::Duration::TAKES_FOREVER);
+    AddTestCase(new WifiPrimaryChannelsTest(MHz_u{160}, false), TestCase::Duration::TAKES_FOREVER);
 #endif
     AddTestCase(new Wifi20MHzChannelIndicesTest(), TestCase::Duration::QUICK);
 }
